import tornado.httpserver
import tornado.ioloop
import tornado.options
import tornado.web
import tornado.websocket
import time
import threading
import subprocess, os
import signal


class LedHandler(tornado.websocket.WebSocketHandler):
        
    

    def check_origin(self, origin):
        return True

    def open(self):
        print("Connection opened from: {}".format(self.request.remote_ip))
        self.write_message("Connection opened")
        
    def on_close(self):
            print("Connection closed")

    def on_message(self, message):
        global run

        if run ==1:
            print("Message received {}".format(message))
            
            if str(message[:10]) != "Connection":
                if str(message[:4]) == "cvlc":
                    subprocess.Popen("/home/pi/radioExec/findkill_channel.sh", stdout=subprocess.PIPE, shell=True,preexec_fn=os.setsid)
                    time.sleep(2)
                print(str(message))
                subprocess.Popen(str(message), stdout=subprocess.PIPE, shell=True,preexec_fn=os.setsid)


def socketloop():
    global io_loop
    global server
    try:
        tornado.options.parse_command_line()
        app = tornado.web.Application(handlers=[(r"/", LedHandler)])
        server = tornado.httpserver.HTTPServer(app)
        server.listen(8000)
        io_loop = tornado.ioloop.IOLoop.instance()
        io_loop.start()
    except RuntimeError:
        print("server already on")


if __name__ == "__main__":
        global io_loop
        global server
        global run
        
        try:
            run = 0
            while True :
                if run == 0:
                    print("  Started")
                    run = 1
                    try:
                        server.stop()
                        io_loop.stop()
                    except:
                        print("Caught threadWebsocket. Thread was already off")
                    our_thread = threading.Thread(target=socketloop)
                    our_thread.start()


        except KeyboardInterrupt:
            print("  Quit")
